# DEMO 1

sugo_menuelem = iface.helpMenu()
menusor = sugo_menuelem.parentWidget()
menusor.removeAction(sugo_menuelem.menuAction()) # eltünteti a Súgót
menusor.addAction(sugo_menuelem.menuAction()) # visszahelyezi a Súgót

from qgis.PyQt.QtCore import Qt
terkepvaszon = iface.mapCanvas()
terkepvaszon.setCanvasColor(Qt.black) # háttérszínt feketére állítja
terkepvaszon.refresh() # frissíti a képernyőt
terkepvaszon.setCanvasColor(Qt.white) # visszaállítja fehérre
terkepvaszon.refresh()

ablak = iface.mainWindow()
dir(ablak) # listázza az ablakhoz elérhető összes metódust és tulajdonságot
ablak.windowTitle() # lekéri az ablak címét
ablak.setWindowTitle( "Ez az új cím") # módosítja az ablak címét

# DEMO 2

kivalasztott_reteg = iface.activeLayer()
type(kivalasztott_reteg) # <class 'qgis._core.QgsVectorLayer'>
kivalasztott_reteg.name()

megnyitott_projekt = QgsProject.instance()

osszes_reteg = megnyitott_projekt.mapLayers()
print(osszes_reteg)
egyik_reteg = list(osszes_reteg.values())[1] # a 2. réteg
dir(egyik_reteg) # listázza a vektorrétegtípushoz elérhető összes metódust és tulajdonságot
egyik_reteg.name()
egyik_reteg.type() # <QgsMapLayerType.VectorLayer: 0>
egyik_reteg.isEditable()
egyik_reteg.isTemporary()
egyik_reteg.id()

egyik_reteg.startEditing() # megnyitja szerkesztésre a réteget
for reteg in osszes_reteg.values(): # végigiterál a rétegeken
	if reteg.isEditable(): # ha szerkeszthető
		print("A(z) '" + reteg.name() + "' nevű réteg szerkeszthető.")
	else: # ha nem
		print("A(z) '" + reteg.name() + "' nevű réteg nem szerkeszthető.")

egyik_reteg.rollBack() # megszünteti a szerkeszthetőséget (az esetleges módosításokat visszavonja)

iface.setActiveLayer(egyik_reteg) # mintha egérrel a második rétegre kattintanánk

megnyitott_projekt.removeMapLayer(layer = egyik_reteg) # eltávolítja a rétegkezelőből
terkepvaszon.refresh() # frissíti a képernyőt

megnyitott_projekt.mapLayersByName(layerName = "nincs ilyen") # lekéri a rétegeket név alapján, üres listát ad vissza
latnivalok_nevu_retegek_listaja = megnyitott_projekt.mapLayersByName(layerName = "latnivalok") # egyelemű listát ad vissza
latnivalok_nevu_retegek_listaja
latnivalok = latnivalok_nevu_retegek_listaja[0]
latnivalok.id()

# DEMO 3

munkamappa = "s:/Oktatás, tanulás/Oktatás, tanulás 2022_23_2_tavasz/Open Source GIS/gyakorlat/04 Python használata QGIS-ben – konzol, szerkesztő, kifejezések"
uj_reteg = iface.addVectorLayer(vectorLayerPath = munkamappa + "/patakok_rossz_nevvel.shp", baseName = "patakok", providerKey = "ogr") # megpróbálja betölteni a nem létező vektorfájlt
if not uj_reteg or not uj_reteg.isValid(): # ha sikertelen a betöltés
	print("Nem sikerült a réteg betöltése.")

uj_reteg = iface.addVectorLayer(vectorLayerPath = munkamappa + "/patakok.shp", baseName = "patakok", providerKey = "ogr") # betölti a vektorfájlt
if not uj_reteg or not uj_reteg.isValid():
	print("Nem sikerült a réteg betöltése.")

pilis_dem = iface.addRasterLayer(rasterLayerPath = munkamappa + "/pilis.tif", baseName = "pilis") # betölti a raszterfájlt
if not pilis_dem or not pilis_dem.isValid():
	print("Nem sikerült a réteg betöltése.")

type(pilis_dem) # <class 'qgis._core.QgsRasterLayer'>
dir(pilis_dem)
pilis_dem.name()
pilis_dem.type() # listázza a raszterrétegtípushoz elérhető összes metódust és tulajdonságot
pilis_dem.id()
pilis_dem.isEditable()
pilis_dem.isTemporary()

# Feladat 1

dir(Qt)
vaszon = iface.mapCanvas()
vaszon.setCanvasColor(Qt.gray)
vaszon.refresh()
tavak = iface.addVectorLayer(vectorLayerPath = munkamappa + "/tavak.shp", baseName = "tavak", providerKey = "ogr")
if tavak and tavak.isValid():
	print("Sikerült betölteni a réteget.")

if iface.activeLayer().id() != tavak.id():
	iface.setActiveLayer(tavak)

projekt = QgsProject.instance()
for reteg in projekt.mapLayers().values():
	if reteg.isEditable():
		reteg.commitChanges()

# DEMO 4

turatervek = megnyitott_projekt.mapLayersByName(layerName = "turatervek")[0]
for mezo in turatervek.fields(): # végiglépked a mezőkön
	print("A(z) '" + mezo.name() + "' nevű mező típusa: " + mezo.typeName())

masodik_mezo = turatervek.fields()[1]
masodik_mezo.comment()
masodik_mezo.alias()
masodik_mezo.setAlias(alias = "túra neve")
masodik_mezo.alias()

# DEMO 5

for turaterv in turatervek.getFeatures(): # végiglépked az elemeken (sorokon)
	print("A(z) " + str(turaterv.id()) + " azonosítójú túra '" + turaterv["település"] + "' településről indul.")
	if turaterv["dzsindzsás"]:
		print("\tés nem csak jelölt utakon vezet...")

# DEMO 6

latnivalok = megnyitott_projekt.mapLayersByName(layerName = "latnivalok")[0]
for latnivalo in latnivalok.getFeatures(): # végiglépked az elemeken (sorokon)
	if latnivalo["nev"] == "szikla":
		geometria = latnivalo.geometry()
		eov_y = str(round(geometria.asPoint().x())) # lekéri a vízszintes koordinátát
		eov_x = str(round(geometria.asPoint().y())) # lekéri a függőleges koordinátát
		print("Ennek a névtelen sziklának a koordinátái: " + eov_y + ", " + eov_x + ".")

# DEMO 7

kozeptajak = megnyitott_projekt.mapLayersByName(layerName = "kozeptajak")[0]
megnyitott_projekt.removeMapLayer(layer = kozeptajak) # eltávolítja a rétegkezelőből
kozeptajak = QgsVectorLayer(path = munkamappa + "/kozeptajak.shp", baseName = "kozeptajak", providerLib = "ogr")
for kozeptaj in kozeptajak.getFeatures(): # végiglépked az elemeken (sorokon)
	azonosito = kozeptaj["középtáj"]
	geometria = kozeptaj.geometry()
	terulet = geometria.area() / 100 ** 3 # lekéri a területet és átváltja m2-ből km2-be
	print("A(z) " + azonosito + " azonosítójú középtáj területe " + str(round(terulet)) + " km2.")

# DEMO 8

latnivalok = megnyitott_projekt.mapLayersByName(layerName = "latnivalok")[0]
latnivalok.selectAll()
latnivalok.removeSelection()

turatervek = megnyitott_projekt.mapLayersByName(layerName = "turatervek")[0]
for turaterv in turatervek.getFeatures():
	if not turaterv["teljesített"]:
		teljesitendo_tura_azonositoja = turaterv.id()
		turatervek.select(featureId = teljesitendo_tura_azonositoja)
		print("A(z) " + str(teljesitendo_tura_azonositoja) + " azonosítójú túrát (\"" + turaterv["nev"] + "\") hozzáadtam a kijelöléshez.")

turatervek.selectedFeatureIds()
kijelolt_elemek = turatervek.selectedFeatures()
tajegysegek = set()
for kijelolt_elem in kijelolt_elemek:
	tajegysegek.add(kijelolt_elem["tájegység"])

print(tajegysegek)
turatervek.removeSelection()

# Feladat 2

latnivalok = megnyitott_projekt.mapLayersByName(layerName = "latnivalok")[0]
latnivalok.selectAll()
for kijelolt_latnivalo in latnivalok.selectedFeatures():
	if kijelolt_latnivalo["nev"] == "gerinc":
		geometria = kijelolt_latnivalo.geometry()
		eov_y = str(round(geometria.asPoint().x()))
		eov_x = str(round(geometria.asPoint().y()))
		print("A(z) " + str(kijelolt_latnivalo.id()) + " azonosítójú hegygerinc koordinátái: " + eov_y + ", " + eov_x + ".")

turatervek = megnyitott_projekt.mapLayersByName(layerName = "turatervek")[0]
for turaterv in turatervek.getFeatures():
	geometria = turaterv.geometry()
	hossz_km = geometria.length() / 1000
	if hossz_km > 25 and turaterv["dzsindzsás"]:
		nehez_tura_azonositoja = turaterv.id()
		turatervek.select(featureId = nehez_tura_azonositoja)
		print("A(z) " + str(nehez_tura_azonositoja) + " azonosítójú túrát kijelöltem.")

print(len(turatervek.selectedFeatureIds()))

# DEMO 9

import math
from qgis.core import *
from qgis.gui import *
@qgsfunction(args = 0, group = "Custom", usesgeometry = True)
def UTM_zonat_megallapit(value1, feature, parent):
	geometria = feature.geometry()
	hosszusag = geometria.asPoint().x()
	szelesseg = geometria.asPoint().y()
	sorszam = math.floor(((hosszusag + 180) / 6) % 60) + 1
	if szelesseg >= 0:
		betujel = "N"
	else:
		betujel = "S"
	return str(int(sorszam)) + betujel


# DEMO 10

UTM_zonat_megallapit() = '33N' # elemkiválasztáshoz
UTM_zonat_megallapit() # új mező számításához (mezőkalkulátor)
name + ' (UTM: ' +  UTM_zonat_megallapit() + ')' # egyszerű címke megjelenítéséhez

# Feladat 3

from qgis.core import *
from qgis.gui import *
@qgsfunction(args = 0, group = "Custom", usesgeometry = True)
def EOV_teruletere_esik(value1, feature, parent):
	geometria = feature.geometry()
	eov_y = geometria.asPoint().x()
	eov_x = geometria.asPoint().y()
	return eov_x < 400000 and eov_y > 400000

# EOV_teruletere_esik()
# NOT EOV_teruletere_esik()
